#include <stdio.h>

#include "itk/itk.h"

using namespace Itk ;

//----------------------------------------------------------------------
int sub1(int argc, char** argv) {

   SimpleSexp2 * s1 = SimpleSexp2::scan("(a :b c)") ;
   ITK_DBG(s1) ;

   SimpleSexp2 * s2 = SimpleSexp2::scan("(abc (def ; ghi
jkl 1) 2 3 4)") ;
   ITK_DBG(s2) ;
   ITK_DSC(*s2) ;
   ITK_DBG(s1) ;

   SimpleSexp2 * s3 = SimpleSexp2::scan("(abc") ;
   ITK_DBG(s3) ;

   Itk::nop() ;
   SimpleSexp2 * s4 = SimpleSexp2::scan("") ;
   ITK_DBG(s4) ;

   SimpleSexp2 * s5 = SimpleSexp2::scan("(a b \"c d e f\" g)") ;
   ITK_DBG(s5) ;

   SimpleSexp2 * s6 = SimpleSexp2::scan("(a b \"c 
d e f\" g)") ;
   ITK_DBG(s6) ;

   cout << "Input S expression:" << ends ;
   SimpleSexp2 * s7 = SimpleSexp2::scan(cin) ;
   ITK_DBG(s7) ;

   return 0 ;

}

//----------------------------------------------------------------------
#define SEXPFILENAME "/usr/users/noda/.emacs"

int sub2(int argc, char** argv) {
   SimpleSexp2::Scanner scanner(new ifstream(SEXPFILENAME)) ;
   SimpleSexp2 * s;
   while(!(s = scanner.scan())->isEof()) {
      ITK_DBG(s) ;
   } ;

   return 0 ;
} ;


//----------------------------------------------------------------------
int main(int argc, char** argv) {
   sub1(argc,argv) ;
   sub2(argc,argv) ;

   return 0 ;
}

   
