// -*- Mode:C++ -*-
//Header:
//File: VBpLinkWrap.h
//Author: NODA, Itsuki
//Date: 2000/01/12
//

//ModifyHistory:
// 2000/01/12: Start to create this file
//EndModifyHistory:

#ifndef _Nnn_VBpLinkWrap_h_
#define _Nnn_VBpLinkWrap_h_
////////////////////////////////////////////////////////////////////////

#include "n3btype.h"
#include "n3utility.h"
#include "StrForm.h"

namespace Nnn {

   using namespace Itk ;

   //======================================================================
   // VBpLinkBaseWrap

   class VBpLinkWrap : public WithDescriber {

	 //--------------------------------------------------
	 // StrForm Label
      public:
	 static char* const LblTermHead = "VBpLW" ; 
	 static char* const LblWeight = "w" ;  

	 //--------------------------------------------------
	 // dummy value
      private:
	 static Val _dummy ;

	 //--------------------------------------------------
	 // member
      public:
	 Val & w ;
	 Val & dw ;

	 //--------------------------------------------------
	 // constructor
      public:
	 VBpLinkWrap(Val & rw, Val & dwr) : w(rw), dw(rw) {} ;
	 VBpLinkWrap(Val & rw) : w(rw), dw(_dummy) {} ;
	 VBpLinkWrap() : w(_dummy), dw(_dummy) {} ;

	 //--------------------------------------------------
	 // save 
      public:
	 virtual void save(ostream & ostr) const ;

	 //--------------------------------------------------
	 // load
      public:
	 virtual void scan(StrForm & sform) ;

	 //--------------------------------------------------
	 // describe
      public:
	 virtual void describe(ostream & ostr, 
			       const Bool detailp = True) const {
	    ostr << "#VBpLinkWrap[" 
		 << "w=" << NNN_VAL_FORMAT << w
		 << "]" ;

	    if(detailp) {
	       ostr << endl ;
	       ostr << "\t" << "w(" << &w << ")=" 
		    << NNN_VAL_FORMAT << w << endl ;
	       ostr << "\t" << "dw(" << &dw << ")=" 
		    << NNN_VAL_FORMAT << dw << endl ;
	    } 
	 } ;
   } ;

} ;
////////////////////////////////////////////////////////////////////////
#endif
