## -*- Mode: Ruby -*-

require 'gtk' ;
require "itkUtility" ;
require "NnnViewUnit.rb" ;

module NnnViewer

  UnitSize = 30 ;

  ##======================================================================
  ## class LayerWidget

  class Layer 
    
    attr :name		,true ;
    attr :unit		,true ;

    attr :parent	,true ;
    attr :alignment	,true ;
    attr :frame		,true ;
    attr :hbox		,true ;

    attr :unitSize	,true ;

    ##------------------------------------------------------------
    ## initialize

    def initialize(name,parent)

      @parent = parent ;
    
      @alignment = Gtk::Alignment::new(0,0,0,0) ;
      @parent.add(@alignment) ;
    
      @frame = Gtk::Frame::new(name) ;
      @alignment.add(@frame) ;

      @hbox = Gtk::HBox::new() ;
      @frame.add(@hbox) ;

      @unit = Array.new() ;
    end

    ##------------------------------------------------------------
    ## set name & size

    def setup(name,size)
      if(name) then setName(name) ; end ;
      setSize(size) ;
    end

    ##----------------------------------------
    ## set name

    def setName(name)
      @frame.set_label(name) ;
    end

    ##----------------------------------------
    ## set size

    def setSize(size) 
      if (@unit.size < size)
	for i in @unit.size..(size-1) do
	  @unit[i] = Unit::new(UnitSize,UnitSize) ;
	  @hbox.add(@unit[i]) ;
	  @unit[i].valmax = 50.0 ;  #####
	  @unit[i].show ;
	end
      end
    end

    ##------------------------------------------------------------
    ## set unit value

    def setUnitValue(i,v)
      unit[i].changeVal(v) ;
    end

  end

end

