// -*- Mode:C++ -*-
//Header:
//File: statcheck.cc
//Author: NODA, Itsuki
//Date: 2000/01/14
//

//ModifyHistory:
// 2000/01/14: create this file
//EndModifyHistory:

//Usage:
//    % statcheck [NETFILE]
//EndUsage:

#include <fstream.h>
#include "VBpNetBase.h"

using namespace Nnn ;

int main(int argc, char * argv[]) {

   char * netfile = ITK_NULLPTR ;
   
   if(argc > 1) {
      netfile = argv[1] ;
   }

   VBpNetBase net ;

   if(isNull(netfile)) {
      net.load(cin) ;
   } else {
      ifstream f(netfile) ;
      net.load(f) ;
   }

   for(VBpLayerTable::Iterator lyr = net.layerTable.begin() ;
       lyr < net.layerTable.end() ; lyr++) {
      Val min, max, ave, div ;
      (*lyr)->thr().getAveDiv(ave,div) ;
      (*lyr)->thr().getMinMax(min,max) ;
      cout << setw(22) << (char*)(*lyr)->name << " : " 
	   << "a=" << NNN_VAL_FORMAT << ave << ", "
	   << "s=" << NNN_VAL_FORMAT << sqrt(div) << ", "
	   << "range=[" 
	   << NNN_VAL_FORMAT << min << ","
	   << NNN_VAL_FORMAT << max << "]" 
	   << endl ;
   }
   
   cout << endl ;

   for(VBpLLinkTable::Iterator lnk = net.linkTable.begin() ;
       lnk < net.linkTable.end() ; lnk++) {
      Val min, max, ave, div ;
      (*lnk)->w().getAveDiv(ave,div) ;
      (*lnk)->w().getMinMax(min,max) ;
      cout << setw(10) << (char*)(*lnk)->fromname << "->" 
	   << setw(10) << (char*)(*lnk)->toname << " : " 
	   << "a=" << NNN_VAL_FORMAT << ave << ", "
	   << "s=" << NNN_VAL_FORMAT << sqrt(div) << ", "
	   << "range=[" 
	   << NNN_VAL_FORMAT << min << ","
	   << NNN_VAL_FORMAT << max << "]" 
	   << endl ;
   }

}


